# tablice z możliwymi ruchami z danego położenia
# zmiany2 zawiera wszystkie możliwe ułożenia zmiany1
zmiany1 = [10, -10, 1, -1]
zmiany2 = []
for i in range(4):
    for j in range(4):
        if j == i:
            continue
        for k in range(4):
            if k in [i, j]:
                continue
            for l in range(4):
                if l in [i, j, k]:
                    continue
                zmiany2.append([zmiany1[i], zmiany1[j], zmiany1[k], zmiany1[l]])

# zmienna resetująca tablicę odwiedzonych pól
def odwres(odw):
    for i in range(100):
        odw[i] = False
    return odw


# funkcja, która rekurencyjnie (wywołując samą siebie) sprawdza, czy z danego miejsca wychodzi poszukiwane słowo
def reku(tab, napis, lok, lit, odw, zmiany):
    if lit == len(napis):
        return True
    odw[lok] = True
    for i in range(4):
        if lok + zmiany[i] >= 100 or lok + zmiany[i] < 0:
            continue
        if zmiany[i] == 1 or zmiany[i] == -1:
            if (lok + zmiany[i]) // 10 != lok // 10:
                continue
        if odw[lok + zmiany[i]]:
            continue
        if tab[lok + zmiany[i]] == napis[lit]:
            if reku(tab, napis, lok + zmiany[i], lit + 1, odw, zmiany):
                return True
    return False
            
# główna funkcja
def sol(tab, napis):
    # minodp - minimalna odpowiedź. Odpowiedź musi być mniejsza niż 1000, więc jeśli na koniec będzie wartość 1000, to nie ma wyrazu
    minodp = 1000
    odw = []
    for i in range(100):
        odw.append(False)

    # dla każdego pola sprawdzamy czy w nim może się rozpocząć poszukiwane słowo
    for i in range(100):
        if(tab[i] == napis[0]):
            # dla każdego możliwego ułożenia zmian rekurencyjnie (funkcją reku) sprawdzamy czy z danego miejsca wychodzi poszukiwane słowo
            for j in range(len(zmiany2)):
                zmiany = zmiany2[j]
                if reku(tab, napis, i, 1, odw, zmiany):
                    minodp = min(minodp, i + 1)
                odw = odwres(odw)
    if minodp != 1000:
        return minodp
    return -1
            
            
# po rozpoczęciu programu wczytujemy od użytkownika wejście i podajemy odpowiedź z głównej funkcji
tab = input()
napis = input()
print(sol(tab, napis))
